Index: /trunk/tools/drawing.py
===================================================================
--- /trunk/tools/drawing.py	(revision 677)
+++ /trunk/tools/drawing.py	(revision 678)
@@ -2535,5 +2535,5 @@
     draw_timeSeries(filen, values, variable):
       filen= name of the file
-      values= [gvarname]:[timetit]:[tkind]:[timefmt]:[title]:[locleg]:[gkind]:[colorlines]:[pointtype]
+      values= [gvarname]:[timetit]:[tkind]:[timefmt]:[title]:[locleg]:[gkind]:[colorlines]:[pointtype]:[pointfreq]
       [gvarname]: name of the variable to appear in the graph
       [timetit]: title of the time axis (assumed x-axis, '|' for spaces)
@@ -2555,4 +2555,5 @@
       [pointtype]: ',' list of type of points for the lines, None for automatic, single
           value all the same
+      [pointfreq]: frequency of point plotting, 'all' for all time steps
       variables= [varname],[timename] names of variable and variable with times
       draw_timeSeries('wrfout_d01_1979-12-01_00:00:00_bottom_top_B6-E6-I1_south_north_B3-E3-I1_west_east_B26-E26-I1.nc', 'dt_con:time|($[DD]^{[HH]}$):exct,12,h:$%d^{%H}$:time|evolution|at|-1|6|3|26:1:pdf', 'LDQCON,time')
@@ -2567,5 +2568,5 @@
 
     expectargs = ['[gvarname]', '[timetit]', '[tkind]', '[timefmt]', '[title]',      \
-      '[locleg]', '[gkind]', '[colorlines]', '[pointtype]']
+      '[locleg]', '[gkind]', '[colorlines]', '[pointtype]','[pointfreq]']
  
     drw.check_arguments(fname,len(expectargs),values,':',expectargs)
@@ -2580,4 +2581,5 @@
     colorlines = values.split(':')[7]
     pointtype = values.split(':')[8]
+    pointfreq0 = values.split(':')[9]
     
     ncobj = NetCDFFile(filen, 'r')
@@ -2622,7 +2624,12 @@
         pttype = pointtype.split(',')
 
+    if pointfreq0 == 'all':
+        pointfreq = None
+    else:
+        pointfreq = int(pointfreq0)
+
     drw.plot_TimeSeries(tseriesvals, Spot + drw.units_lunits(gunits), tunits,        \
-      'TimeSeries', gvarname, timetit, tkind, timefmt, title,      \
-      gvarname.replace('_','\_'), locleg, gkind, collines, pttype)
+      'TimeSeries', gvarname, timetit, tkind, timefmt, title,                        \
+      gvarname.replace('_','\_'), locleg, gkind, collines, pttype, pointfreq)
 
     return
Index: /trunk/tools/drawing_tools.py
===================================================================
--- /trunk/tools/drawing_tools.py	(revision 677)
+++ /trunk/tools/drawing_tools.py	(revision 678)
@@ -2454,5 +2454,5 @@
 
 def plot_TimeSeries(valtimes, vunits, tunits, hfileout, vtit, ttit, tkind, tformat,  \
-  tit, linesn, lloc, kfig,coll,ptl):
+  tit, linesn, lloc, kfig,coll,ptl,ptf):
     """ Function to draw time-series
       valtimes= list of arrays to plot [vals1[1values, 1times], [...,valsM[Mvals,Mtimes]]) 
@@ -2480,4 +2480,5 @@
       ptl= ',' list of type of points for the lines, None for automatic, single
           value all the same
+      ptf= frequency of point plotting, 'all' for all time steps
     """
     fname = 'plot_TimeSeries'
@@ -2490,16 +2491,35 @@
     Nlines = len(valtimes)
 # Canging line kinds every 7 lines (end of standard colors)
+    pointkindsauto=['.', 'x', 'o', '*', 'o', '<', '>', '5']
+    Npts = len(pointkindsauto)
     linekinds = []
+    pointkinds = []
     if ptl is None:
-        linekindsauto=['.-','x-','o-']
-        for ptype in range(3):
-            for ip in range(7):
-                linekinds.append(linekindsauto[ptype])
-    else:
-        if len(ptl) > 1:
-            linekinds = ptl
+        if ptf is None:
+            for ptype in range(Npts):
+                for ip in range(7):
+                    linekinds.append(pointkindsauto[ptype] + '-')
         else:
-            for il in range(Nlines):
-                linekinds.append(ptl+'-')
+            for ptype in range(Npts):
+                for ip in range(7):
+                    linekinds.append('-')
+                    pointkinds.append(pointkindsauto[ptype])
+    else:
+        if ptf is None:
+            if len(ptl) > 1:
+               for pt in ptl:
+                    linekinds.append(pt + '-')
+            else:
+                for il in range(Nlines):
+                    linekinds.append(ptl+'-')
+        else:
+            if len(ptl) > 1:
+               for pt in ptl:
+                    linekinds.append('-')
+                    pointkinds.append(pt)
+            else:
+                for il in range(Nlines):
+                    linekinds.append('-')
+                pointkinds = ptl
 
     Nvalues = []
@@ -2559,9 +2579,38 @@
             array[0,:] = np.where(array[0,:] < 98000., None, array[0,:])
 
-        if coll is None:
-            plt.plot(array[1,:],array[0,:], linekinds[il], label= linesn[il])
+        if ptf is None:
+            if coll is None:
+                if ptf is None:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il])
+                else:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il])
+                    plt.plot(array[1,::ptf],array[0,::ptf], pointkinds[il],          \
+                      label=linesn[il])
+            else:
+                if ptf is None:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il], \
+                      color=coll[il])
+                else:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il], \
+                      color=coll[il])
+                    plt.plot(array[1,::ptf],array[0,::ptf], pointkinds[il],          \
+                      label=linesn[il], color=coll[il])
         else:
-            plt.plot(array[1,:],array[0,:], linekinds[il], label= linesn[il],   \
-              color=coll[il])
+            if coll is None:
+                if ptf is None:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il])
+                else:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il])
+                    plt.plot(array[1,::ptf],array[0,::ptf], pointkinds[il],          \
+                      label=linesn[il])
+            else:
+                if ptf is None:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il], \
+                      color=coll[il])
+                else:
+                    plt.plot(array[1,:],array[0,:], linekinds[il], label=linesn[il], \
+                      color=coll[il])
+                    plt.plot(array[1,::ptf],array[0,::ptf], pointkinds[il],          \
+                      label=linesn[il], color=coll[il])
 
     timevals = np.arange(xmin,xmax)*1.